
package de.ivu.elect.was.exchange.ergebnis;

import static java.util.Arrays.asList;

import java.util.Collection;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.control.NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext;
import de.ivu.elect.business.security.Customer;
import de.ivu.elect.business.wahl.entity.NlWahlart;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.was.exchange.ergebnis.eml.Eml510bPSBErgebnisExportMapper;

/**
 * @see NlWasModelN11MainDocumentExportMapper
 */
public class NlWasModelN11Eml510bExportMapper extends AbstractNlWasModelN11Eml510xExportMapper {

  @Inject
  private transient Eml510bPSBErgebnisExportMapper eml510bPSBErgebnisExportMapper;

  public NlWasModelN11Eml510bExportMapper() {
    super();
  }

  @Override
  protected boolean isEmlExportMapperAcceptContextOverridden(NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext context) {
    return NlWahlart.GEMEENTERAAD.equalsWahlart(context.getWahl()); // ELECTVAPP-614, cf. NlWasModelIIEml510bExportMapper
  }

  @Override // https://support.elect-it.com/wiki/x/48g8
  protected Collection<NlWahlart> collectWahlartenAccepted() {
    return asList( //
        NlWahlart.TWEEDE_KAMER, //
        NlWahlart.EUROPEES_PARLEMENT, //
        NlWahlart.PROVINCIALE_STATEN1, //
        NlWahlart.PROVINCIALE_STATEN2, //
        NlWahlart.GEMEENTERAAD //
    );
  }

  @Override // https://support.elect-it.com/wiki/x/48g8
  protected boolean isAcceptWahlebene(Wahl wahl, Customer customer) {
    return NlWahlart.isWasPSB(wahl, customer);
  }

  @Override
  protected Eml510bPSBErgebnisExportMapper getEmlExportMapper() {
    return eml510bPSBErgebnisExportMapper;
  }
}
